/*
 * 20210709-18-9999.c
 *
 * 次の漸化式の形で定義された数列 { a_n } の第 102 項目を求めなさい。
 *		a_1 = 65
 *		a_{n+1} = (9 * a_{n} + 4) mod 205
 */

#include <stdio.h>

#include "s_print.h"

/*
 *	コンパイル :
 *		cc -I ~/c/include -c 20210709-18-9999.c
 *		cc -o 20210709-18-9999.exe 20210709-18-9999.o
 *	実行 :
 *		./20210709-18-9999.exe
 */

/*
 * 漸化式に基き、a_n を計算する関数 func(n) を定義する
 */

int func ( int n ) {

	if ( n <= 1 ) {		/* 本当は n == 1 で良いが安全性のため n <= 1 とする */
		/* 初項なので.. */
		return 65;
	} else {			/* n = k + 1 の時は、n = k の値を再帰で求める */
		/* n=k+1 の時、k=n-1 の値を再帰で求める事ができれば */
		/* a_n = a_{k+1} = ( 9 * a_k + 4 ) % 205 = ( 9 * a_{n-1} + 4 ) % 205 */
        /* となるので... */
		return ( 9 * func(n-1) + 4 ) % 205;
	}
}

/*
 *
 */

int main ( void ) {

	s_print_string ( "初項   a_1     = 65\n" );
	s_print_string ( "一般項 a_{n+1} = ( 9 * a_n + 4 ) % 205\n" );
	s_print_string ( "で、定義された数列 {a_n} の第 102 項の値は " );
	s_print_int ( func( 102 ) );
	s_print_string ( " です。\n" );

	return 0;
}

/*
 *
 */

